<?php
// +----------------------------------------------------------------------
// | whitef快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/whitef
// | github下载：https://github.com/likeshop-github/whitef
// | 访问官网：https://www.whitef.cn
// | whitef团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: whitefTeam
// +----------------------------------------------------------------------

namespace app\workerapi\controller;

use app\common\enum\notice\NoticeEnum;
use app\common\model\master_worker\MasterWorker;
use app\common\model\master_worker_register\MasterWorkerRegister;
use app\common\model\notice\NoticeSetting;
use app\common\service\wechat\WeChatOaService;
use app\workerapi\logic\DictLogic;
use app\workerapi\logic\LoginLogic;
use app\workerapi\validate\LoginAccountValidate;
use app\workerapi\validate\RegisterValidate;


/**
 * 登录注册
 * Class LoginController
 * @package app\workerapi\controller
 */
class LoginController extends BaseApiController
{

    public array $notNeedLogin = ['register', 'account', 'logout','testWeChat','getCredentialName'];


    /**
     * @notes 注册账号
     * @return \think\response\Json
     * @author 段誉
     * @date 2022/9/7 15:38
     */
    public function register()
    {
        $params = (new RegisterValidate())->post()->goCheck('register');
        $res = LoginLogic::confirmMobile($params);
        $resCredential = LoginLogic::confirmCredential($params);
        if(!$res || !$resCredential){
            return $this->fail(LoginLogic::getError());
        }
        $result = LoginLogic::register($params);
        if (true === $result) {
            // 发送通知给平台配置的审核人(公众号通知)
            event('Notice',  [
                'scene_id' => 108,
                'params' => [
                    'user_id' => 0,
                    'thing1' => $params['name'],
                    'time2' => date('Y-m-d H:i:s')
                ]
            ]);
            // 工程师提交入驻申请后-发送短信通知
            event('Notice',  [
                'scene_id' => 109,
                'params' => [
                    'user_id' => 0,
                    'mobile' => $params['mobile'],
                ]
            ]);
            return $this->success('注册成功', [], 1, 1);
        }
        return $this->fail(LoginLogic::getError());
    }

    /**
     * 获取证件信息
     * @return \think\response\Json
     */
    public function getCredentialName()
    {
        $res = DictLogic::groupData(['type'=>'credential_name']);
        return $this->success('', $res);
    }


    /**
     * @notes 账号密码/手机号密码/手机号验证码登录
     * @return \think\response\Json
     * @author 段誉
     * @date 2022/9/16 10:42
     */
    public function account()
    {
        $params = (new LoginAccountValidate())->post()->goCheck();

        $worker_register = MasterWorkerRegister::where('mobile',$params['account'])->findOrEmpty();
        if($worker_register->isEmpty()) {
            return $this->fail('请点击下方的工程师入驻',[],402);
        }

        $result = LoginLogic::login($params);
        if (false === $result) {
            return $this->fail(LoginLogic::getError());
        }
        //if(!empty($params['wx_code']) and $params['terminal']==1){
        if(!empty($params['wx_code'])){
            $params['code'] = $params['wx_code'];
            $params['user_id'] = MasterWorker::where('sn',$result['sn'])->value('id');
            $wx_result = LoginLogic::mnpAuthLogin($params);
            if ($wx_result === false) {
                return $this->fail(LoginLogic::getError());
            }
        }
        return $this->data($result);
    }


    /**
     * @notes 退出登录
     * @return \think\response\Json
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author 段誉
     * @date 2022/9/16 10:42
     */
    public function logout()
    {
        LoginLogic::logout($this->userInfo);
        return $this->success();
    }
}